<xsl:transform 
   version="2.0" 
   xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:prov="http://www.w3.org/ns/prov#">
<xsl:output method="text"/>

<xsl:key name="prefix" match="//prov:prefix" use="@prov:id"/>

<xsl:template match="/">

   <xsl:variable name="prefix" select="substring-before(//prov:entity/@prov:ref,':')"/>

   <xsl:variable name="magic" select="concat('magic(',$prefix,')=http://example.com/ns/ex#')"/>

   <!-- Cannot access /prov:document/@xmlns:ex using a variable-constructed XPath.
    xsl:variable name="magic1" select="concat(prov:document/xmlns:',$prefix,')"/
   -->

   <!-- These two work, but require an addition of a <prov:prefix> element -->
   <xsl:variable name="magic2" select="//prov:prefix[@prov:id=$prefix]"/>
   <xsl:variable name="magic3" select="key('prefix',$prefix)"/>
   <xsl:variable name="magic4" select="namespace-uri-for-prefix($prefix,//prov:entity)"/>

   <xsl:value-of select="concat('The full URI of your painting is ',
                                $magic4,
                                substring-after(//prov:entity/@prov:ref,':'))"/>
</xsl:template>

</xsl:transform>
