// $Id: Langname_Scanner.hh,v 1.1 2008-04-06 17:10:46 eric Exp $

#ifndef ${Langname}Scanner_H
#define ${Langname}Scanner_H

// Flex expects the signature of yylex to be defined in the macro YY_DECL, and
// the C++ parser expects it to be declared. We can factor both as follows.

#ifndef YY_DECL

#define	YY_DECL						\
    ${Langname}NS::${Langname}Parser::token_type				\
    ${Langname}NS::${Langname}Scanner::lex(				\
	${Langname}NS::${Langname}Parser::semantic_type* yylval,		\
	${Langname}NS::${Langname}Parser::location_type* yylloc		\
    )
#endif

#ifndef __FLEX_LEXER_H
#define yyFlexLexer ${Langname}FlexLexer
#include "FlexLexer.h"
#undef yyFlexLexer
#endif

#include "${Langname}Parser.hh"

namespace ${Langname}NS {

/** ${Langname}Scanner is a derived class to add some extra function to the scanner
 * class. Flex itself creates a class named yyFlexLexer, which is renamed using
 * macros to ${Langname}FlexLexer. However we change the context of the generated
 * yylex() function to be contained within the ${Langname}Scanner class. This is required
 * because the yylex() defined in ${Langname}FlexLexer has no parameters. */
class ${Langname}Scanner : public ${Langname}FlexLexer
{
public:
    /** Create a new scanner object. The streams arg_yyin and arg_yyout default
     * to cin and cout, but that assignment is only made when initializing in
     * yylex(). */
    ${Langname}Scanner(std::istream* arg_yyin = 0,
	    std::ostream* arg_yyout = 0);

    /** Required for virtual functions */
    virtual ~${Langname}Scanner();

    /** This is the main lexing function. It is generated by flex according to
     * the macro declaration YY_DECL above. The generated bison parser then
     * calls this virtual function to fetch new tokens. */
    virtual ${Langname}Parser::token_type lex(
	${Langname}Parser::semantic_type* yylval,
	${Langname}Parser::location_type* yylloc
	);

    /** Enable debug output (via arg_yyout) if compiled into the scanner. */
    void set_debug(bool b);
};

} // namespace ${Langname}NS

#endif // ${Langname}Scanner_H
