#!/bin/bash

rapper -g -o turtle ProvenanceOntology.owl > prov-o.ttl

# https://github.com/timrdf/prov-lodspeakr/blob/master/components/services/prov-o/cross-reference.py
# deployed on http://aquarius.tw.rpi.edu/prov-wg/prov-o
# depends on the ordering attributes to be mixed in to the OWL at:
# https://dvcs.w3.org/hg/prov/file/tip/ontology/working-dir/ProvenanceOntology-ordered.owl
rapper -qg -o turtle ProvenanceOntology.owl                             > working-dir/ProvenanceOntology-ordered.ttl
echo "@prefix prov: <http://www.w3.org/ns/prov#> ."                    >> working-dir/ProvenanceOntology-ordered.ttl
cat term-order.csv | awk '$1 ~ /</ {i++; print $1,"prov:order",i,"."}' >> working-dir/ProvenanceOntology-ordered.ttl
rapper -qg -o rdfxml working-dir/ProvenanceOntology-ordered.ttl         > working-dir/ProvenanceOntology-ordered.owl

hg commit ProvenanceOntology.owl prov-o.ttl working-dir/ProvenanceOntology-ordered.owl -m 'auto publish of prov-o as OWL, TTL, and OWL+order'
hg push
